const std = @import("std");
pub fn entry(haystack: []const u8, needle: []const u8) ?struct{usize, usize}
{
	if (needle.len == 0)
	{
		return null;
	}

	var locations: [256]std.ArrayList(usize) = undefined;
	for (locations[0..]) |*point|
	{
		point.* = std.ArrayList(usize).init(std.heap.page_allocator);
	}
	for (haystack, 0..) |character, index|
	{
		locations[character].append(index) catch @panic("Error.");
	}
	const first_character = needle[0];
	if (needle.len == 1)
	{
		if (locations[first_character].items.len > 0)
		{
			return .{
				locations[first_character].items[0],
				0,
			};
		}
		return null;
	}
	for (locations[first_character].items[0..]) |index|
	{
		const second_character = needle[1];
		for (locations[second_character].items[0..]) |index_two|
		{
			const gap = index_two -| index;
			if (gap == 0)
			{
				continue;
			}
			const index_last = index + gap * (needle.len -| 1);
			if (index_last >= haystack.len)
			{
				continue;
			}
			for (2..needle.len) |index_nth|
			{
				const haystack_pos = index + gap * index_nth;
				if (needle[index_nth] != haystack[haystack_pos])
				{
					break;
				}
			}
			else
			{
				return .{
					index,
					gap,
				};
			}
		}
	}
	return null;
}
pub fn main() !void
{
	std.debug.print("{?}, {?}, {?}, {?}\n", .{
		entry("THISBOOKISSOFUCKINGAWESOMEANDIAMTOTALLYGAY", "SAD"),
		entry("THISBOOKISSOFUCKINGAWESOMEANDIAMTOTALLYGAY", "SCAM"),
		entry("THISBOOKISSOFUCKINGAWESOMEANDIAMTOTALLYGAY", "GAY"),
		entry("THISBOOKISSOFUCKINGAWESOMEANDIAMTOTALLYGAY", "SICK"),
	});
}